# norootforbuild

%define name      ffmpeg-compat
%define version   0.4.9svn
%define release   20080906.15
%define major     0
%define lib       libffmpeg
%define libname   %{lib}%{major}
%define majoravcodec     51
%define libavcodec       libavcodec
%define libnameavcodec   %{libavcodec}%{majoravcodec}
%define majoravdevice    52
%define libavdevice      libavdevice
%define libnameavdevice  %{libavdevice}%{majoravdevice}
%define majoravformat    52
%define libavformat      libavformat
%define libnameavformat  %{libavformat}%{majoravformat}
%define majoravutil      49
%define libavutil        libavutil
%define libnameavutil    %{libavutil}%{majoravutil}
%define majorpostproc    51
%define libpostproc      libpostproc
%define libnamepostproc  %{libpostproc}%{majorpostproc}
%define majorswscale     0
%define libswscale       libswscale
%define libnameswscale   %{libswscale}%{majorswscale}

Name:           %{name}
Version:        %{version}
Release:        20080912.17
License:        LGPL v2 or later and some code GPL v2 or later
Group:          Productivity/Multimedia/Video/Editors and Convertors
Summary:        Hyper fast MPEG1/MPEG4/H263/RV and AC3/MPEG audio encoder
Summary(de):    Hyperschneller MPEG1/MPEG4/H263/RV Und AC3/MPEG Audio-Encoder
URL:            http://ffmpeg.sourceforge.net

Source0:        ffmpeg-svn.tar.bz2

Patch0:         ffmpeg_configure.diff
Patch1:		ffmpeg-x264.patch
BuildRoot:      %{_tmppath}/%{name}-buildroot
Prefix:         %{_prefix}
Requires:       %{libnameavcodec} = %{version}-%{release}
Requires:       %{libnameavdevice} = %{version}-%{release}
Requires:       %{libnameavformat} = %{version}-%{release}
Requires:       %{libnameavutil} = %{version}-%{release}
Requires:       %{libnameswscale} = %{version}-%{release}
Requires:       imlib2
Requires:       libmp3lame0
Requires:       libogg
Requires:       libvorbis
Requires:       libtheora
Requires:       ncurses
Requires:       alsa
Requires:       freetype2
Requires:       SDL
Requires:       slang
%if 0%{?suse_version} >= 920
Requires:       xorg-x11-libs
%endif
%if 0%{?suse_version} > 0 && 0%{?suse_version} < 920
Requires:       XFree86-libs
%endif
Requires:       zlib
Requires:       libfaad2_0 >= 2.6
Requires:       libfaac0 >= 1.26
Requires:       libamrnb3
Requires:       libamrwb3
%if 0%{?suse_version} >= 930
BuildRequires:  libdca-devel
BuildRequires:  libdca0
Requires:       libdca0
%endif
BuildRequires:  yasm >= 0.7.1
%if 0%{?suse_version} >= 1010 || 0%{?centos_version} || 0%{?rhel_version} || 0%{?fedora_version}
BuildRequires:  libgsm
BuildRequires:  libgsm-devel
%endif
BuildRequires:  imlib2-devel
BuildRequires:  libmp3lame-devel
BuildRequires:  libogg-devel
BuildRequires:  libvorbis-devel
BuildRequires:  libtheora-devel
BuildRequires:  ncurses-devel
BuildRequires:  libjack0 >= 0.109.2
BuildRequires:  libjack-devel >= 0.109.2
BuildRequires:  alsa-devel
BuildRequires:  freetype2-devel
BuildRequires:  SDL-devel
BuildRequires:  slang-devel
%if 0%{?centos_version} || 0%{?rhel_version} || 0%{?fedora_version}
BuildRequires:  xorg-x11-proto-devel xorg-x11-xtrans-devel
%endif
%if 0%{?suse_version} >= 920
BuildRequires:  xorg-x11-devel
%endif
%if 0%{?suse_version} > 0 && 0%{?suse_version} < 920
BuildRequires:  XFree86-devel
%endif
BuildRequires:  zlib-devel
BuildRequires:  libfaad2_0 >= 2.6
BuildRequires:  libfaad2-devel >= 2.6
BuildRequires:  libfaac-devel >= 1.26
BuildRequires:  x264-compat-devel
BuildRequires:  libx264-60
BuildRequires:  xvid-devel
BuildRequires:  libmp4v2-devel
BuildRequires:  texinfo
BuildRequires:  libamrnb-devel
BuildRequires:  libamrwb-devel
BuildRequires:  liba52dec-devel
BuildRequires:  libdc1394
BuildRequires:  libdc1394-devel
%if 0%{?suse_version} >= 1030
BuildRequires:  libschroedinger-devel >= 1.0.5
BuildRequires:  liboil-devel >= 0.3.15
%endif
%if 0%{?suse_version} >= 1100
BuildRequires:  libnut-devel
%endif
%if 0%{?suse_version} > 1020
BuildRequires:  libdc1394_control12-devel
%endif
#BuildRequires:  G.729-devel

%if 0%{?rhel_version} || 0%{?centos_version} || 0%{?fedora_version}
BuildRequires: texi2html
%endif

%description
ffmpeg is a hyper fast realtime audio/video encoder, a streaming  server
and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it into
several file formats based on DCT/motion compensation encoding. Sound is
compressed in MPEG audio layer 2 or using an AC3 compatible stream.

%description -l de
ffmpeg ist ein hyperschneller realtime Audio-/Video-Encoder, ein Streaming
Server und ein Audio und Video Dateikonverter.

Es kann von einer Standard-Video4Linux-Quelle grabben und in verschiedene
Dateiformate basierend auf einer DCT/motion compensation konvertiern.
Sound wird in einen MPEG audio layer 2 oder AC3 Stream geschrieben.

%package -n %{libnameavcodec}
Group:          System/Libraries
Summary:        ffmpeg %{libavcodec}
Provides:       %{libavcodec} = %{version}-%{release}
%if 0%{?suse_version} >= 1030
Requires:       libschroedinger0 >= 1.0.5
Requires:       liboil0 >= 0.3.15
%endif

%description -n %{libnameavcodec}
ffmpeg %{libavcodec} shared library

%description -n %{libnameavcodec} -l de
ffmpeg %{libavcodec} Bibliothek

%debug_package

%prep
%setup -q -n ffmpeg
%patch0
##%patch1 -p2
%if 0%{?suse_version}
%suse_update_libdir configure
%endif
#don't call ldconfig on install
#perl -pi -e 's/ldconfig \|\| true//' libavcodec/Makefile

%build
archflags=""
%ifarch x86_64 amd64 ia32e
  archflags=" -fPIC"
%endif
%ifarch %ix86
#  archflags=" -pipe -ffast-math -fomit-frame-pointer -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64"
  archflags=" -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64"
  mv libpostproc/Makefile libpostproc/MakefileX
  cat libpostproc/MakefileX | sed -e "s/-fPIC -DPIC//g" > libpostproc/Makefile
%endif

CFLAGS="$RPM_OPT_FLAGS $archflags"
%if 0%{?suse_version} >= 1010 || 0%{?centos_version} || 0%{?rhel_version} || 0%{?fedora_version}
CFLAGS="${CFLAGS} -I%{_includedir}/gsm"
%endif
export archflags
export CFLAGS

./configure --shlibdir=%{_libdir} --prefix=%{_prefix} --mandir=%{_mandir} \
%if 0%{?suse_version} == 910
            --enable-memalign-hack \
%endif
            --libdir=%{_libdir} --enable-shared --enable-libmp3lame \
            --enable-libvorbis --enable-libtheora --enable-libfaad \
            --enable-libfaac --enable-libxvid --enable-liba52 --enable-swscale \
            --enable-postproc --enable-gpl --enable-vhook --enable-x11grab \
%if 0%{?suse_version} >= 1030
            --enable-libschroedinger \
%endif
%if 0%{?suse_version} >= 1100
            --enable-libnut \
%endif
%if 0%{?suse_version} >= 1010
            --enable-libgsm \
%endif
%ifarch ppc
            --disable-altivec \
%endif
            --enable-libx264 --enable-libamr-nb --enable-libamr-wb \
            --enable-libdc1394 --enable-nonfree --enable-pthreads
#--enable-libg729a
%{__make} %{?jobs:-j%{jobs}}

%install
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}
%{__ln_s} libavformat libav
#%{__make} DESTDIR=%{buildroot} mandir=%{buildroot}%{_mandir} \
#   prefix=%{buildroot}%{_prefix} \
#   bindir=%{buildroot}%{_bindir} \
#   libdir=%{buildroot}%{_libdir} \
#   mandir=%{buildroot}%{_mandir} \
#   includedir=%{buildroot}%{_includedir} \
#   install
%__make DESTDIR=%{buildroot} install

%{__mkdir_p} %{buildroot}%{_includedir}/%{name}
%{__mkdir_p} %{buildroot}%{_includedir}/postproc
%{__install} -d %{buildroot}%{_libdir}/libavcodec
%{__rm} -rf doc/.svn
%{__rm} -f doc/Makefile
%{__rm} -rf %{buildroot}%{_bindir}
%{__rm} -rf %{buildroot}%{_libdir}/vhook/*
%{__rm} -rf %{buildroot}%{_mandir}
%{__rm} -f %{buildroot}%{_libdir}/%{libavdevice}*
%{__rm} -f %{buildroot}%{_libdir}/%{libavformat}*
%{__rm} -f %{buildroot}%{_libdir}/%{libavutil}*
%{__rm} -f %{buildroot}%{_libdir}/%{libpostproc}*
%{__rm} -f %{buildroot}%{_libdir}/%{libswscale}*
%{__rm} -rf %{buildroot}%{_includedir}
%{__rm} -f %{buildroot}%{_libdir}/*.*a
%{__rm} -f %{buildroot}%{_libdir}/*.so
%{__rm} -rf %{buildroot}%{_libdir}/libavcodec
%{__rm} -f %{buildroot}%{_libdir}/pkgconfig/*.pc

%clean
[ "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

%files -n %{libnameavcodec}
%defattr(-,root,root)
%{_libdir}/%{libavcodec}.so.%{majoravcodec}*

%changelog
* Sat Dec 27 2008 Carsten Schoene <cs@linux-administrator.com>
- initial import, compat package with svn 15224 (wma playback is now fixed in svn)
